# Copyright (C) 2017  Lars Wirzenius
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
#
# You should have received a copy of the GNU Affero General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.


import ick2


class ControllerAPI:

    def __init__(self):
        self._state = ick2.ControllerState()

    def get_state_directory(self):
        return self._state.get_state_directory()

    def set_state_directory(self, dirname):
        self._state.set_state_directory(dirname)

    def find_missing_route(self, missing_path):  # pragma: no cover
        apis = {
            '/version': ick2.VersionAPI,
            '/builds': ick2.BuildsAPI,
            '/logs': ick2.LogAPI,
            '/projects': ick2.ProjectAPI,
            '/work': ick2.WorkAPI,
            '/workers': ick2.WorkerAPI,
        }

        routes = []
        for path in apis:
            self._state.load_resources(path[1:])
            api = apis[path](self._state)
            routes.extend(api.get_routes(path))
        ick2.log.log('info', msg_texg='Found routes', routes=routes)
        return routes
